:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3216,_3210/_3212,_3220):-(retract(dynamicVersion(_3216,_3210/_3212,_3234))->true;true),asserta(dynamicVersion(_3216,_3210/_3212,_3220)).
prim_assertFact('Dynamic.Dynamic'(_3328),'Prelude.()'):-retract(dynamicTime(_3338)),_3352 is _3338+1,assertz(dynamicTime(_3352)),_3328=..[_3366,_3372,_3378,_3384|_3386],_3414=..[_3366,_3352,0|_3386],assertz(user:_3414),logDynamicEvent(_3372,assertz,_3414).
prim_retractFact('Dynamic.Dynamic'(_3516),_3522):-_3516=..[_3526,_3532,_3538,_3544|_3546],_3574=..[_3526,_3562,_3568|_3546],reloadNewestDynamicVersionOf(_3526),retract(dynamicTime(_3584)),_3598 is _3584+1,assertz(dynamicTime(_3598)),call(user:_3574),isInTimeInterval(_3584,_3562,_3568),!,_3648=..[_3526,_3562,_3584|_3546],retract(user:_3574),!,logDynamicEvent(_3532,retract,_3574),assertz(user:_3648),_3522='Prelude.True'.
prim_retractFact(_3814,'Prelude.False').
prim_getDynamicKnowledge(_3850):-reloadNewestDynamicVersions,dynamicTime(_3854),term2partcall('Dynamic.isKnownAtTime'(_3854),1,_3850),(compileWithSharing(function)->makeShare(_3850,_3876);_3876=_3850).
prim_isKnownAtTime(_3954,'Dynamic.Dynamic'(_3950),'Prelude.True'):-_3950=..[_3962,_3968,_3974,_3980|_3982],_4010=..[_3962,_3998,_4004|_3982],call(user:_4010),isInTimeInterval(_3954,_3998,_4004).
isInTimeInterval(_4102,_4104,_4106):-_4102>=_4104,(_4106=0->true;_4102=<_4106).
logDynamicEvent('Dynamic.Temporary',_4198,_4200):-!.
logDynamicEvent('Dynamic.Persistent',_4256,_4258):-_4258=..[_4262,_4268,_4274|_4276],_4304=..[_4262,0,0|_4276],_4322=..[_4256,_4304],user:dynamicPredInfo(_4262/_4330,_4336),logDynamic(_4322,_4336).
logDynamic(_4426,_4428):-dir2tmplockfile(_4428,_4434),lockWithFileIfNotInTransaction(_4434),executeWithFinalize((dir2logfile(_4428,_4444),open(_4444,append,_4452),writeq(_4452,_4426),put_code(_4452,46),nl(_4452),flush_output(_4452),close(_4452),addChangePid(_4428)),unlockWithFileIfNotInTransaction(_4434)).
executeWithFinalize(_4590,_4592):-on_exception(_4600,_4590,(call(_4592),printError(_4600),!,fail)),!,call(_4592).
executeWithFinalize(_4688,_4690):-call(_4690),!,fail.
prim_startTransaction(_4752):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4814,initTransaction(_4752),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4814),fail)),!.
initTransaction(_4896):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4900)),_4896 is _4900+1,assertz(dynamicTime(_4896)),logAllDynamicPreds(startTransaction(_4896)).
prim_commitTransaction(_5000,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_5000)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5084):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5092),map1partialM(prim_dynamic:addChangePid(0),_5092),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5198):-findall(_5202,isDynamicDir(_5202),_5210),sort(_5210,_5198).
isDynamicDir(_5260):-user:dynamicPredInfo(_5264,_5260),\+_5260=''.
logAllDynamicPreds(_5326):-getDynamicDirs(_5330),map1partialM(prim_dynamic:logDynamic(_5326),_5330).
initializeDynamic:-user:dynamicPredInfo(_5390/_5392,_5398),initializeDynamic(_5398,_5390/_5392),fail.
initializeDynamic.
initializeDynamic('',_5468/_5470):-!,retractAllFacts(_5468/_5470).
initializeDynamic(_5544,_5538/_5540):-existsDirectory(_5544),!,checkDynSpec(_5544,_5538/_5540),setDynamicVersion(_5544,_5538/_5540,0),!.
initializeDynamic(_5646,_5648):-existsFile(_5646),!,appendAtom('ERROR: Directory "',_5646,_5660),appendAtom(_5660,'" for dynamic entries cannot be created!',_5668),writeErr(_5668),nlErr,!,fail.
initializeDynamic(_5766,_5760/_5762):-upDirectory(_5766,_5774),(existsDirectory(_5774)->createDynamicDir(_5766,_5760/_5762),setDynamicVersion(_5766,_5760/_5762,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5766),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5952,_5954):-atom_codes(_5952,_5960),append(_5970,[47|_5966],_5960),\+member(47,_5966),!,atom_codes(_5954,_5970).
upDirectory(_6060,'.').
checkDynSpec(_6102,_6096/_6098):-dir2specfile(_6102,_6110),existsFile(_6110),readPrologTermFile(_6110,_6120),dynamicSpec(_6096/_6098,_6120),!.
checkDynSpec(_6202,_6204):-appendAtom('ERROR: Directory "',_6202,_6212),appendAtom(_6212,'" contains no matching dynamic entries!',_6220),writeErr(_6220),nlErr,!,fail.
replayLogFile(_6306,_6300/_6302):-dir2tmplockfile(_6306,_6314),lockWithFileIfNotInTransaction(_6314),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6306,_6300/_6302),unlockWithFileIfNotInTransaction(_6314)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6422,_6416/_6418):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6422),writeErr('\'...'),nlErr;true),getRunTime(_6476),ensurePakcsVersion(_6422),dir2dbfile(_6422,_6486),dir2pofile(_6422,_6492),consultPrologorPOFile(_6486,_6492),dir2logfile(_6422,_6504),open(_6504,read,_6512),(atEndOfStream(_6512)->close(_6512);assert(replayStatus(unchanged)),repeat,on_exception(_6542,readAndReplay(_6512),((printError(_6542)->true;true),writeErr('ERROR during reading of '),writeErr(_6504),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6512),retract(replayStatus(_6606)),writeNewDatabaseIfChanged(_6416/_6418,_6422,_6606)),updateDynFactsIfNecessary(_6422,_6416/_6418),readDynamicVersion(_6422,_6678),setDynamicVersion(_6422,_6416/_6418,_6678),writeChangePids(_6422,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6712),_6722 is _6712-_6476,writeErr(_6722),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6904):-readPAKCSVersion(_6904,_6910),_6910=pakcsVersion(_6914,_6916),prologMajor(_6926),\+_6926=_6916,dir2pofile(_6904,_6942),(existsFile(_6942)->deleteFile(_6942);true),writePAKCSVersion(_6904),!.
ensurePakcsVersion(_7046).
isCurrentPakcsVersion(_7072):-readPAKCSVersion(_7072,_7078),compilerVersion(_7082),!,(_7078=compilerVersion(_7082)->writePAKCSVersion(_7072);_7078=pakcsVersion(_7082,_7108)).
readPAKCSVersion(_7176,_7178):-dir2pakcsversionfile(_7176,_7184),existsFile(_7184),readPrologTermFile(_7184,_7178).
writePAKCSVersion(_7252):-dir2pakcsversionfile(_7252,_7258),compilerVersion(_7262),prologMajor(_7266),writePrologTermFile(_7258,pakcsVersion(_7262,_7266)).
updateDynFactsIfNecessary(_7334,_7336):-isCurrentPakcsVersion(_7334),!.
updateDynFactsIfNecessary(_7398,_7392/_7394):-compilerVersion(_7404),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7398),writeErr('\' to compiler version '),writeErr(_7404),writeErr(...),nlErr;true),updateDynFacts(_7392/_7394),writeNewDatabaseIfChanged(_7392/_7394,_7398,changed),writePAKCSVersion(_7398).
updateDynFactsIfNecessary(_7570,_7572).
updateDynFacts(_7606/_7608):-functor(_7616,_7606,_7608),functor(_7624,_7606,_7608),retract(user:_7616),arg(1,_7616,_7646),arg(1,_7624,_7646),arg(2,_7616,_7662),arg(2,_7624,_7662),translateDynFactArgs(3,_7608,_7616,_7624),asserta(user:_7624),fail.
updateDynFacts(_7782).
translateDynFactArgs(_7808,_7810,_7812,_7814):-_7808>_7810,!.
translateDynFactArgs(_7888,_7890,_7892,_7894):-arg(_7888,_7892,_7902),translateDynFactArg(_7902,_7908),arg(_7888,_7894,_7908),_7926 is _7888+1,translateDynFactArgs(_7926,_7890,_7892,_7894).
translateDynFactArg(_8024,_8024):-var(_8024),!.
translateDynFactArg(_8082,_8082):-number(_8082),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8620,_8622):-atomic(_8620),atom_codes(_8620,[40|_8632]),!,appendAtom('Prelude.',_8620,_8622).
translateDynFactArg(_8710,_8712):-atom(_8710),atom_codes(_8710,[39|_8722]),!,(_8722=[_8732]->char_int(_8712,_8732);_8722=[78,85,76]->char_int(_8712,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8874,_8874):-atomic(_8874),!.
translateDynFactArg(_8932,_8934):-functor(_8932,_8940,_8942),translateDynFactArg(_8940,_8948),functor(_8934,_8948,_8942),translateDynFactArgs(1,_8942,_8932,_8934).
writeNewDatabaseIfChanged(_9030/_9032,_9038,changed):-!,dir2dbfile(_9038,_9046),dir2pofile(_9038,_9052),dir2logfile(_9038,_9058),appendAtom(_9046,'.bak',_9066),tell(_9066),writeq((:-dynamic _9030/_9032)),put_code(46),nl,listing(user:_9030/_9032),told,try_save_predicates(_9030/_9032,_9052),renameFile(_9066,_9046),appendAtom(_9058,'.bak',_9134),renameFile(_9058,_9134),appendAtom('touch ',_9058,_9148),shellCmd(_9148),readDynamicVersion(_9038,_9158),_9168 is _9158+1,writeDynamicVersion(_9038,_9168),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9378/_9380,_9386,_9388):-dir2logfile(_9386,_9394),appendAtom(_9394,'.bak',_9402),renameFile(_9394,_9402),appendAtom('touch ',_9394,_9416),shellCmd(_9416).
readAndReplay(_9498):-atEndOfStream(_9498),!.
readAndReplay(_9546):-read(_9546,_9552),replayEvent(_9546,_9552).
replayEvent(_9602,end_of_file):-!.
replayEvent(_9654,startTransaction(_9650)):-readAndReplayTransaction(_9654,_9650,[]),!,fail.
replayEvent(_9722,_9724):-retract(replayStatus(_9728)),assert(replayStatus(changed)),call(user:_9724),!,fail.
readAndReplayTransaction(_9820,_9822,_9824):-atEndOfStream(_9820),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9822),nlErr;true).
readAndReplayTransaction(_9932,_9934,_9936):-read(_9932,_9942),(_9942=commitTransaction(_9934)->callRevList(_9936);_9942=abortTransaction->true;readAndReplayTransaction(_9932,_9934,[_9942|_9936])),!.
callRevList([]).
callRevList([_10092|_10094]):-callRevList(_10094),retract(replayStatus(_10106)),assert(replayStatus(changed)),call(user:_10092).
startTransaction(_10184).
commitTransaction(_10210).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10248),map1M(prim_dynamic:lockDynamicDir,_10248).
lockDynamicDir(_10294):-dir2lockfile(_10294,_10300),lockWithFile(_10300).
lockWithFileIfNotInTransaction(_10348):-insideTransaction->true;lockWithFile(_10348).
lockWithFile(_10402):-appendAtom('lockfile-create --lock-name ',_10402,_10410),(existsFile(_10402),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10402),writeErr('\'...'),nlErr;true),shellCmd(_10410),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10528),map1M(prim_dynamic:unlockDynamicDir,_10528).
unlockDynamicDir(_10574):-dir2lockfile(_10574,_10580),unlockWithFile(_10580).
unlockWithFileIfNotInTransaction(_10628):-insideTransaction->true;unlockWithFile(_10628).
unlockWithFile(_10682):-existsFile(_10682),!,appendAtom('lockfile-remove --lock-name ',_10682,_10694),shellCmd(_10694).
unlockWithFile(_10754).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10780/_10782,_10788),dynamicVersion(_10788,_10780/_10782,_10808),reloadNewestDynamicVersion(_10788,_10780/_10782,_10808),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10880):-dynamicVersion(_10890,_10880/_10886,_10894),!,reloadNewestDynamicVersion(_10890,_10880/_10886,_10894).
reloadNewestDynamicVersionOf(_10958).
reloadNewestDynamicVersion(_10990,_10984/_10986,0):-!,retractAllFacts(_10984/_10986),replayLogFile(_10990,_10984/_10986),!.
reloadNewestDynamicVersion(_11094,_11088/_11090,_11098):-readDynamicVersion(_11094,_11104),\+_11098=_11104,!,retractAllFacts(_11088/_11090),replayLogFile(_11094,_11088/_11090),!.
reloadNewestDynamicVersion(_11220,_11222,_11224):-readChangePids(_11220,_11230),currentPID(_11234),(_11230=[];_11230=[_11234]),!.
reloadNewestDynamicVersion(_11336,_11330/_11332,_11340):-retractAllFacts(_11330/_11332),replayLogFile(_11336,_11330/_11332).
createDynamicDir(_11428,_11422/_11424):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11428),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11428,_11486),shellCmd(_11486),dir2logfile(_11428,_11496),appendAtom('touch ',_11496,_11504),shellCmd(_11504),dir2dbfile(_11428,_11514),appendAtom('touch ',_11514,_11522),shellCmd(_11522),dir2specfile(_11428,_11532),dynamicSpec(_11422/_11424,_11544),writePrologTermFile(_11532,_11544),writePAKCSVersion(_11428).
readPrologTermFile(_11672,_11674):-open(_11672,read,_11682),read(_11682,_11674),close(_11682).
writePrologTermFile(_11750,_11752):-open(_11750,write,_11760),writeq(_11760,_11752),put_code(_11760,46),nl(_11760),flush_output(_11760),close(_11760).
readDynamicVersion(_11860,_11862):-dir2versionfile(_11860,_11868),existsFile(_11868),!,on_exception(_11888,readPrologTermFile(_11868,_11862),_11862=0).
readDynamicVersion(_11956,1).
writeDynamicVersion(_11992,_11994):-dir2versionfile(_11992,_12000),writePrologTermFile(_12000,_11994).
readChangePids(_12058,_12060):-dir2changepidsfile(_12058,_12066),existsFile(_12066),!,on_exception(_12092,readPrologTermFile(_12066,_12060),_12060=[0]).
readChangePids(_12160,[]).
writeChangePids(_12196,_12198):-dir2changepidsfile(_12196,_12204),writePrologTermFile(_12204,_12198).
addChangePid(_12262):-currentPID(_12266),addChangePid(_12266,_12262).
addChangePid(_12316,_12318):-readChangePids(_12318,_12324),(member(_12316,_12324)->true;writeChangePids(_12318,[_12316|_12324])),!.
dynamicSpec(_12412/_12414,dynamicPredicate(_12412,_12414)).
retractDeadDynamicFacts(_12460/_12462):-length(_12470,_12462),_12482=..[_12460|_12470],_12470=[_12488,_12494|_12496],dynamicTime(_12506),call(user:_12482),_12494>0,_12506>_12494,retract(user:_12482),fail.
retractDeadDynamicFacts(_12624).
dir2logfile(_12650,_12652):-appendAtom(_12650,'/eventlog',_12652).
dir2lockfile(_12706,_12708):-appendAtom(_12706,'/LOCK',_12708).
dir2tmplockfile(_12762,_12764):-appendAtom(_12762,'/LOCK',_12764).
dir2dbfile(_12818,_12820):-appendAtom(_12818,'/database.pl',_12820).
dir2pofile(_12874,_12876):-appendAtom(_12874,'/dbpred.po',_12876).
dir2specfile(_12930,_12932):-appendAtom(_12930,'/spec',_12932).
dir2pakcsversionfile(_12986,_12988):-appendAtom(_12986,'/pakcsversion',_12988).
dir2versionfile(_13042,_13044):-appendAtom(_13042,'/version',_13044).
dir2changepidsfile(_13098,_13100):-appendAtom(_13098,'/changepids',_13100).
