:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3186):-(getEnv('PAKCS_LOCALHOST',_3192)->true;_3192=no),(_3192=yes->asserta(only_localhost(yes)),_3186=yes;asserta(only_localhost(no)),_3186=no),retract((only_localhost(_3272):-_3276,_3278)),!.
tracePorts(unknown).
ifTracePort(_3370):-tracePorts(_3374),(_3374=unknown->retract(tracePorts(_3384)),(getEnv('PAKCS_TRACEPORTS',_3394)->true;_3394=no),(_3394=yes->asserta(tracePorts(yes)),_3370;asserta(tracePorts(no)));_3374=yes->_3370;true).
prim_openPort(_3538,_3540,_3542):-nonvar(_3538),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3628,_3630,_3632):-nonvar(_3630),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3724),_3724,'Prelude.True').
prim_openPortOnSocket(_3774,_3776,_3778):-(retract(mySocket('Ports.internalPort'(_3782,_3784,_3786,_3788)))->_3806 is _3786+1,asserta(mySocket('Ports.internalPort'(_3782,_3784,_3806,_3788))),(_3774=_3784,_3776=_3806->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3774),on_exception(_3912,listenOnNewSocket(_3774,_3894,_3788),(write('ERROR: openPortOnSocket "'),write(_3774),write('":'),nl,printError(_3912),!,fail)),atom2String(_3894,_3782),(var(_3776)->_3776=0;true),asserta(mySocket('Ports.internalPort'(_3782,_3774,_3776,_3788)))),mySocket(_4036),_4036='Ports.internalPort'(_4040,_4042,_4044,_4046),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_4044),writeErr(' at socket '),writeErr(_4042),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_4040,_4092),writeErr(_4092)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4036),_3778);_3778='Ports.basicServerLoop'(_4036)).
trySetSocketNumber(_4272):-var(_4272),getEnv('PAKCS_SOCKET',_4282),atom_codes(_4282,_4288),number_codes(_4272,_4288),!.
trySetSocketNumber(_4356).
prim_basicServerLoop(_4660,_4662,_4664,_4666):-freeze(_4664,blocked_prim_basicServerLoop(_4660,_4662,_4664,_4666)).
blocked_prim_basicServerLoop(_4728,_4730,_4732,_4734):-readPort(_4728,_4740,-1),_4730=[_4740|_4748],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4728),_4748);_4748='Ports.basicServerLoop'(_4728)),_4732=_4734.
prim_timeoutOnStream(_5156,_5158,_5160,_5162,_5164):-freeze(_5162,blocked_prim_timeoutOnStream(_5156,_5158,_5160,_5162,_5164)).
blocked_prim_timeoutOnStream(_5234,_5236,_5238,_5240,_5242):-user:derefRoot(_5234,_5248),prim_timeoutOnStream_exec(_5248,_5236,_5238,_5240,_5242).
prim_timeoutOnStream_exec(_5342,_5344,'Prelude.Nothing',_5348,_5350):-var(_5344),!,_5348=_5350.
prim_timeoutOnStream_exec(_5446,share(_5442),_5450,_5452,_5454):-!,get_mutable(_5458,_5442),(_5458='$eval'(_5464)->_5450=_5464,_5452=_5454;prim_timeoutOnStream_exec(_5446,_5458,_5502,_5452,_5454),(_5502='Prelude.Nothing'->_5450=_5502;(compileWithSharing(variable)->user:propagateShare(_5502,_5450);_5502=_5450),update_mutable('$eval'(_5450),_5442))).
prim_timeoutOnStream_exec(_5678,[],'Prelude.Just'([]),_5684,_5686):-!,_5684=_5686.
prim_timeoutOnStream_exec(_5784,[_5768|_5770],'Prelude.Just'([_5768|_5770]),_5790,_5792):-!,_5790=_5792.
prim_timeoutOnStream_exec(_5878,'Ports.basicServerLoop'(_5874),_5882,_5884,_5886):-(readPort(_5874,_5892,_5878)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5874),_5908);_5908='Ports.basicServerLoop'(_5874)),_5882='Prelude.Just'([_5892|_5908]);_5882='Prelude.Nothing'),_5884=_5886.
send_extvar_binding(_6324,_6326,_6328,_6330):-freeze(_6326,blocked_send_extvar_binding(_6324,_6326,_6328,_6330)).
blocked_send_extvar_binding(_6392,_6394,_6396,_6398):-evalToken(_6402),user:normalizeAndCheck(_6394,_6408,_6402,_6412),user:waitUntilGround(_6408,_6412,_6426),eval_send_extvar_binding(_6392,_6408,_6396,_6426,_6398).
eval_send_extvar_binding(_6828,_6830,_6832,_6834,_6836):-freeze(_6834,blocked_eval_send_extvar_binding(_6828,_6830,_6832,_6834,_6836)).
blocked_eval_send_extvar_binding(nostream,_6908,_6910,_6912,_6914):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6910),writeErr(': '),writeErr(_6908),nlErr,!.
blocked_eval_send_extvar_binding(_7030,_7032,_7034,_7036,_7038):-show4sending(_7032,_7044,_7046),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_7034),writeErr(': '),writeChars(user_error,_7044),nlErr)),number_codes(_7034,_7098),putChars(_7030,[86|_7098]),put_code(_7030,10),writeChars(_7030,_7044),put_code(_7030,10),flush_output(_7030),!,_7038=done.
readPort('Ports.internalPort'(_7262,_7264,_7266,_7268),_7274,_7276):-var(_7268),!,string2Atom(_7262,_7286),writeErr('ERROR: readPort: Port '),writeErr(_7264),writeErr(/),writeErr(_7266),writeErr(@),writeErr(_7286),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7428,_7430,_7432,_7434),_7440,_7442):-on_exception(_7456,readFromSocket(_7432,_7434,_7440,_7442),(printError(_7456)->_7440=[];_7440=[])),!.
checkIncomingPortStreams(_7548,_7550,_7552):-retract(incomingPortStreams(_7548,[message(_7550,_7552)|_7564])),asserta(incomingPortStreams(_7548,_7564)),!.
checkIncomingPortStreams(_7650,_7652,_7654):-retract(incomingPortStreams(_7650,[ping(_7658,_7660)|_7666])),asserta(incomingPortStreams(_7650,_7666)),answerPingOnStream(_7658,_7660),checkIncomingPortStreams(_7650,_7652,_7654),!.
answerPingOnStream(_7778,_7780):-write(_7780,ok),put_code(_7780,10),flush_output(_7780),closeSocketStream(_7778,_7780),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7886,_7888,_7890,_7892):-checkIncomingPortStreams(_7886,_7898,_7900),!,readStreamLine(_7898,_7906),(parse_received_message(_7898,_7900,_7906,_7890)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7906),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7906),nlErr,readFromSocket(_7886,_7888,_7890,_7892)),!.
readFromSocket(_8078,_8080,_8082,_8084):-waitForSocketClientStream(_8080,_8084,_8092,_8094,_8096),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8092),nlErr)),(readPortMessage(_8078,_8094,_8096,_8130)->(parse_received_message(_8094,_8096,_8130,_8082)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8130),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8130),nlErr,readFromSocket(_8078,_8080,_8082,_8084));readFromSocket(_8078,_8080,_8082,_8084)),!.
readFromSocket(_8318,_8320,_8322,_8324):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8406,_8408,_8410,_8412):-readStreamLine(_8408,_8418),_8418=[_8422|_8424],checkMessageHeader(_8422,_8408,_8410,_8440),number_codes(_8444,_8424),!,(_8444=_8406->readPortMessageBody(_8440,_8412);(retract(incomingPortStreams(_8444,_8470))->append(_8470,[_8440],_8488);_8488=[_8440]),asserta(incomingPortStreams(_8444,_8488)),!,fail).
checkMessageHeader(78,_8638,_8640,message(_8638,_8640)):-!.
checkMessageHeader(80,_8712,_8714,ping(_8712,_8714)):-!.
checkMessageHeader(_8786,_8788,_8790,_8792):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8876,_8878),_8884):-readStreamLine(_8876,_8884).
readPortMessageBody(ping(_8936,_8938),_8944):-answerPingOnStream(_8936,_8938),!,fail.
prim_sendPort(_9246,_9248,_9250,_9252,_9254):-freeze(_9252,blocked_prim_sendPort(_9246,_9248,_9250,_9252,_9254)).
blocked_prim_sendPort(_9324,_9326,_9328,_9330,_9332):-user:derefAll(_9324,_9338),user:derefRoot(_9326,_9350),prim_sendPortExec(_9338,_9350,_9328,_9330,_9332).
prim_sendPortExec(_9460,'Ports.internalPort'(_9450,0,_9454,_9456),'Prelude.True',_9466,_9468):-!,add2Stream(_9456,_9460),_9466=_9468.
prim_sendPortExec('Ports.SP_Put'(_9562),'Ports.internalPort'(_9566,-1,_9570,_9572),'Prelude.True',_9582,_9584):-!,user:waitUntilGround(_9562,_9582,_9584),writeChars(_9572,_9562),nl(_9572),flush_output(_9572),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9562),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9738),'Ports.internalPort'(_9742,-1,_9746,_9748),'Prelude.True',_9758,_9760):-!,readStreamLine(_9742,_9766),map2M(basics:char_int,_9778,_9766),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9778),nlErr)),user:constrEq(_9778,_9738,_9814,_9758,_9760).
prim_sendPortExec('Ports.SP_GetChar'(_9918),'Ports.internalPort'(_9922,-1,_9926,_9928),'Prelude.True',_9938,_9940):-!,get_code(_9922,_9946),char_int(_9946,_9952),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9952),nlErr)),user:constrEq(_9952,_9918,_9984,_9938,_9940).
prim_sendPortExec('Ports.SP_EOF'(_10088),'Ports.internalPort'(_10092,-1,_10096,_10098),'Prelude.True',_10108,_10110):-!,(atEndOfStream(_10092)->_10118='Prelude.True';_10118='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10118),nlErr)),user:constrEq(_10088,_10118,_10170,_10108,_10110).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10268,-1,_10272,_10274),'Prelude.True',_10284,_10286):-!,close(_10274),close(_10268),_10284=_10286.
prim_sendPortExec(_10398,'Ports.internalPort'(_10388,-1,_10392,_10394),'Prelude.True',_10404,_10406):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10398),nlErr,_10404=_10406.
prim_sendPortExec(_10524,'Ports.internalPort'(_10514,_10516,_10518,_10520),'Prelude.True',_10530,_10532):-string2Atom(_10514,_10538),on_exception(_10572,send2Socket(_10538,_10516,_10518,_10524),(write('ERROR: send to port '),write(_10518),write(@),write(_10538),write(:),nl,(printError(_10572)->true;true))),_10530=_10532.
add2Stream(_10716,_10718):-var(_10716),!,_10716=[_10718|_10728].
add2Stream([],_10794):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10850|_10852],_10858):-add2Stream(_10852,_10858).
prim_ping(_10924,'Ports.internalPort'(_10910,0,_10914,_10916),'Prelude.Just'(0)):-!.
prim_ping(_10996,'Ports.internalPort'(_10982,-1,_10986,_10988),'Prelude.Just'(0)):-!.
prim_ping(_11064,'Ports.internalPort'(_11054,_11056,_11058,_11060),_11068):-string2Atom(_11054,_11074),on_exception(_11096,ping2SocketPort(_11074,_11056,_11058,_11064,_11068),_11068='Prelude.Nothing').
ping2SocketPort(_11160,_11162,_11164,_11166,_11168):-connect2socket(_11160,_11162,_11176,_11178),number_codes(_11164,_11184),putChars(_11178,[80|_11184]),put_code(_11178,10),flush_output(_11178),getElapsedTime(_11210),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11162),writeErr(/),writeErr(_11164),writeErr(@),writeErr(_11160),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11176],_11166,_11298),(_11298=0->readStreamLine(_11176,_11310),closeSocketStream(_11176,_11178),getElapsedTime(_11320),_11330 is _11320-_11210,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11330),writeErr(' ms'),nlErr)),_11168='Prelude.Just'(_11330);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11168='Prelude.Nothing').
prim_connectPortAtSocket(_11572,_11574,_11576,'Ports.internalPort'(_11562,_11564,_11566,'Prelude.()')):-user:derefRoot(_11572,_11564),user:derefRoot(_11574,_11566),user:derefAll(_11576,_11562),!.
send2Socket(_11694,_11696,_11698,_11700):-connect2socket(_11694,_11696,_11708,_11710),number_codes(_11698,_11716),putChars(_11710,[78|_11716]),put_code(_11710,10),show4sending(_11700,_11740,_11742),writeChars(_11710,_11740),put_code(_11710,10),flush_output(_11710),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11696),writeErr(/),writeErr(_11698),writeErr(@),writeErr(_11694),writeErr('": '),writeChars(user_error,_11740),nlErr)),rev(_11742,_11850),receive_extvar_bindings(_11708,_11850).
receive_extvar_bindings(_11978,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_11978).
receive_extvar_bindings(_12056,_12058):-readStreamLine(_12056,_12064),_12064=[86|_12070],number_codes(_12080,_12070),readStreamLine(_12056,_12088),(deleteIndexVariable(_12080,_12058,_12096,_12098)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12098=_12058),(parse_received_message(nostream,nostream,_12088,_12142)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12080),writeErr(': '),putChars(user_error,_12088),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12088),nlErr),!,_12096=_12142,receive_extvar_bindings(_12056,_12098).
show4sending(_12328,_12330,_12332):-numberVars(_12328,_12338,[],_12332),show_term(_12338,qualified,_12330,[]).
getVariableIndex(_12424,[(_12412,_12414)|_12420],_12414):-_12424==_12412,!.
getVariableIndex(_12500,[_12494|_12496],_12504):-getVariableIndex(_12500,_12496,_12504).
getIndexVariable(_12568,[(_12566,_12568)|_12574],_12566):-!.
getIndexVariable(_12642,[_12636|_12638],_12646):-getIndexVariable(_12642,_12638,_12646).
deleteIndexVariable(_12710,[(_12708,_12710)|_12716],_12708,_12716):-!.
deleteIndexVariable(_12800,[_12788|_12790],_12804,[_12788|_12796]):-deleteIndexVariable(_12800,_12790,_12804,_12796).
parse_received_message(_12878,_12880,_12882,_12884):-readTerm(_12882,qualified,_12892,_12894),skipWhiteSpace(_12892,[]),extractVars(_12894,_12884,[],_12910),send_extvar_bindings(_12910,_12916,_12880),closeStreamAfterDones(_12916,_12878,_12880).
send_extvar_bindings([],[],_13016).
send_extvar_bindings([(_13058,_13060)|_13066],[_13070|_13072],_13080):-send_extvar_binding(_13080,_13058,_13060,_13070),send_extvar_bindings(_13066,_13072,_13080).
closeStreamAfterDones([],nostream,_13162):-!.
closeStreamAfterDones([],_13218,_13220):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13218,_13220).
closeStreamAfterDones([_13300|_13302],_13308,_13310):-closeStreamAfterDones(_13300,_13302,_13308,_13310).
closeStreamAfterDones(_13658,_13660,_13662,_13664):-freeze(_13658,blocked_closeStreamAfterDones(_13658,_13660,_13662,_13664)).
blocked_closeStreamAfterDones(_13726,_13728,_13730,_13732):-closeStreamAfterDones(_13728,_13730,_13732).
prim_openProcessPort(_13812,'Ports.internalPort'(_13802,-1,0,_13808)):-user:derefAll(_13812,_13820),string2Atom(_13820,_13832),execCommand(_13832,_13808,_13802,_13842).
prim_choiceSPEP(_14192,_14194,_14196,_14198,_14200):-freeze(_14194,freeze(_14198,blocked_prim_choiceSPEP(_14192,_14194,_14196,_14198,_14200))).
blocked_prim_choiceSPEP(_14276,_14278,_14280,_14282,_14284):-user:derefRoot(_14276,_14290),prim_choiceSPEP_exec(_14290,_14278,_14280,_14282,_14284).
prim_choiceSPEP_exec(_14388,share(_14384),_14392,_14394,_14396):-!,get_mutable(_14400,_14384),(_14400='$eval'(_14406)->_14394=_14396,_14392='Prelude.Right'(_14406);prim_choiceSPEP_exec(_14388,_14400,_14448,_14394,_14396),(_14448='Prelude.Left'(_14456)->_14392=_14448;_14448='Prelude.Right'(_14478),(compileWithSharing(variable)->user:propagateShare(_14478,_14494);_14478=_14494),_14392='Prelude.Right'(_14494),update_mutable('$eval'(_14494),_14384))).
prim_choiceSPEP_exec(_14672,[_14656|_14658],'Prelude.Right'([_14656|_14658]),_14678,_14680):-!,_14678=_14680.
prim_choiceSPEP_exec('Ports.internalPort'(_14762,-1,_14766,_14768),[],_14776,_14778,_14780):-readStreamLine(_14762,_14786),map2M(basics:char_int,_14798,_14786),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14798),nlErr)),_14776='Prelude.Left'(_14798),_14778=_14780,!.
prim_choiceSPEP_exec(_14946,'Ports.basicServerLoop'(_14942),_14950,_14952,_14954):-_14942='Ports.internalPort'(_14958,_14960,_14962,_14964),checkIncomingPortStreams(_14962,_14976,_14978),!,readStreamLine(_14976,_14984),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14942),_14998);_14998='Ports.basicServerLoop'(_14942)),(parse_received_message(_14976,_14978,_14984,_15030)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15030),nlErr)),_14950='Prelude.Right'([_15030|_14998]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_14984),nlErr,prim_choiceSPEP_exec(_14946,_14998,_14950,_14952,_14954)),_14952=_14954,!.
prim_choiceSPEP_exec('Ports.internalPort'(_15246,-1,_15250,_15252),'Ports.basicServerLoop'(_15256),_15264,_15266,_15268):-_15256='Ports.internalPort'(_15272,_15274,_15276,_15278),waitForSocketOrInputStreams(_15278,_15296,_15298,_15300,[_15246],_15304),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_15256),_15318);_15318='Ports.basicServerLoop'(_15256)),(_15296=no->readStreamLine(_15246,_15352),map2M(basics:char_int,_15364,_15352),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_15364),nlErr)),_15264='Prelude.Left'(_15364);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_15296),nlErr)),(readPortMessage(_15276,_15298,_15300,_15460)->(parse_received_message(_15298,_15300,_15460,_15470)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15470),nlErr)),_15264='Prelude.Right'([_15470|_15318]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_15460),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_15246,-1,_15540,_15252),_15318,_15264,_15266,_15268));prim_choiceSPEP_exec('Ports.internalPort'(_15246,-1,_15592,_15252),_15318,_15264,_15266,_15268))),_15266=_15268,!.
numberVars(_15734,'VAR'(_15730),_15738,_15740):-var(_15734),!,(getVariableIndex(_15734,_15738,_15730)->_15740=_15738;length(_15738,_15730),_15740=[(_15734,_15730)|_15738]).
numberVars(_15874,_15876,_15878,_15880):-isShowableArg(_15874),_15874=..[_15888|_15890],numberVarsList(_15890,_15902,_15878,_15880),_15876=..[_15888|_15902].
numberVarsList([],[],_16002,_16002).
numberVarsList([_16054|_16056],[_16060|_16062],_16070,_16072):-numberVars(_16054,_16060,_16070,_16082),numberVarsList(_16056,_16062,_16082,_16072).
extractVars(_16160,_16160,_16164,_16164):-var(_16160),!.
extractVars('VAR'(_16238),_16244,_16246,_16248):-!,(getIndexVariable(_16238,_16246,_16244)->_16248=_16246;_16248=[(_16244,_16238)|_16246]).
extractVars(_16360,_16362,_16364,_16366):-_16360=..[_16370|_16372],extractVarsList(_16372,_16384,_16364,_16366),_16362=..[_16370|_16384].
extractVarsList([],[],_16478,_16478).
extractVarsList([_16530|_16532],[_16536|_16538],_16546,_16548):-extractVars(_16530,_16536,_16546,_16558),extractVarsList(_16532,_16538,_16558,_16548).
prim_after(_16854,_16856,_16858,_16860):-freeze(_16858,blocked_prim_after(_16854,_16856,_16858,_16860)).
blocked_prim_after(_16922,_16924,_16926,_16926):-raise_exception('Ports.after not implemented!').
